code	segment	'code'
	assume	cs:code,ds:code

	org	2ch
envseg	label	word			; pointer to environment segment

	org	100h
start:	jmp	near ptr init		; jump to install routine
	dw	0

new21:	cmp	ax,3800h		; Get Country-Specific Information?
	jne	start

	pushf				; call older handler
	push	cs
	call	start

	push	bp
	mov	bp,sp
	mov	ax,21h			; country code (21h=France, 31h=Germany)
	mov	bx,ax
	and	word ptr [bp+6],not 1	; clear carry flag on stack
	pop	bp
	iret

init:	mov	ax,3521h		; create jump to old handler
	int	21h
	inc	byte ptr start
	mov	word ptr start+1,bx
	mov	word ptr start+3,es

	mov	dx,offset new21		; install new handler
	mov	ah,25h
	int	21h

	mov	es,envseg		; free environment segment
	mov	ah,49h
	int	21h

	mov	dx,0012h		; terminate leaving DX para resident
	mov	ax,3100h
	int	21h

code	ends

	end	start
